/* released as free software under Gnu Public License terms, in Jan 2010 */
/* Was written in 1989 to compile with a PD compiler */
/* from Mark A Johnson,of Boulder CO, USA  */



#include        <c:\compiler\stdio.h>
#include        <c:\compiler\gem.h>      /* assorted useful GEM macro's    */
#include        <c:\compiler\obdefs.h>
#include	<c:\mt32.h>

#define Getrez()        (int)trap(14,4)  /* taken from osbind.h */
#define Crawcin()       trap(1,0x7)
#define Cconws(z)       trap(1,0x9,z)
#define Rand()		trap(14,17)

extern char __atab[];
#define isalnum(c) (__atab[c]&(4|8|16))

typedef int WORD;


OBJECT *tree_addr;
TEDINFO *obspec;
GRECT  box[4];
OBJECT 	*menu_addr;
OBJECT  *box_addr;
OBJECT  *com_addr;
OBJECT  *ran_addr;
BITBLK  *img_addr;
OBJECT  *ryt_addr;
OBJECT  *sys_addr;

typedef struct {
		unsigned char name[11];
		int common[4];
		int partial[4][58];
		}
	voices;

typedef struct {
		int group;
		int number;
		int key_shift;
		int fine_tune;
		int bend_range;
		int ass_mode;
		int rev_sw;
		int dummy;
		}
	patchmem;
	
patchmem patch_memory[128];	
voices voice;	
char rythm[256];
char rytmax[4]={94,100,14,1};


char patch_name[4][64][11];
WORD ret_code;
int mem_flag=0;	    /* flag to indicate if voice in memory */
int crntuser=3;
int current_edit;   /* memory voice being edited */
int crntpatch;      /* patch being edited */
int crntchan=0;	    /* basic chanel currently selected */
int chan_contents[8]={68,48,95,78,41,3,110,123};
		    /* initial patches on power up of MT32 */			
int system[23];     /* contents of system area */


char name[128];  /* for voice saving and loading */
char full_name[128];
char global_path[128];
int *fd;




char *dectoa();	

WORD    contrl[12],
	intout[128],intin[128],
	ptsin[128],ptsout[128];

WORD	screen_vhandle,	
	screen_phandle,
	screen_rez,
	color_screen,
	x_max,
	m_hidden,
	y_max;

unsigned char message[256];  /* prepared message for midiout */
char ttaddr[16]={0,0,1,118,3,108,5,98,7,88,9,78,11,68,13,58}; /* start addresses of patch temp */
char partmax[58]={96,100,16,1,1,127,100,14,10,100,4,
                  100,100,100,100,100,100,100,100,
                  100,100,100,100,100,30,14,127,14,
                  100,100,4,4,100,100,100,100,100,
                  100,100,100,100,100,100,127,12,127,
                  12,4,4,100,100,100,100,100,100,100,
                  100,100};   /* max values in partial */

char patchmax[7]={3,63,48,100,24,3,1};/* max patch values */

char param_value[4];
char carry;       /* used in 7 bit address add */


main()
{
int ap_id;
WORD gr_wchar, gr_hchar,
     gr_wbox, gr_hbox;
     
	ap_id = appl_init();
	if (ap_id < 0)
	{
	Cconws("***> Initialisation error.<***\n");
	Cconws("Press any key to continue\n ");
	Crawcin();
	exit(-1);
	}
	
screen_phandle = graf_handle(&gr_wchar, &gr_hchar, &gr_wbox, &gr_hbox);
screen_vhandle = open_vwork(screen_phandle);
set_screen_attr();	/* determine screen attributes */

	get_resource();						/* load the resource file */
	rsrc_gaddr(0,MAINSCRE,&tree_addr);	/* store tree addresses */
	rsrc_gaddr(0, MENS, &menu_addr);  /* menu  */
	rsrc_gaddr(0,TIMBRE1,&box_addr);  /* partials 1 - 4 edit */
	rsrc_gaddr(0,COMMON,&com_addr);   /* common part edit  */
	rsrc_gaddr(0,RANDOM,&ran_addr);   /* randomise screen  */
	rsrc_gaddr(0,RYTHM,&ryt_addr);   /* rythm set-up screen  */
	rsrc_gaddr(0,SYSTEM,&sys_addr);   /* rythm set-up screen  */

init_message();		/* set first four parts of a sys ex message */
check_mt();		/* check prescence of MT32 */
init_mem_voc();		/* set internal voice memory to max values */      	
init_patchmem();        /* load current patches into structure */
init_names();      	/* collect patch names from MT32 */
crntpatch=3;
init_mainscreen();	/* display initial values in mainscreen */
init_system();
	
control();	
	
	
rsrc_free();/* clear the resource memory */
v_clsvwk(screen_vhandle);/* clear the screen */
appl_exit();/* tidy up */
}    




WORD open_vwork(phys_handle)
WORD phys_handle;
{
WORD work_in[11],
     work_out[57],
     new_handle;
int i;
    for(i=0;i<10;i++)
         work_in[i]=1;
    work_in[10]=2;
    new_handle=phys_handle;
    v_opnvwk(work_in,&new_handle,work_out);
    return(new_handle);
}

set_screen_attr()
{
WORD work_out[57];
    vq_extnd(screen_vhandle,0,work_out);
    x_max=work_out[0];
    y_max=work_out[1];
    screen_rez=Getrez();
    color_screen=(screen_rez < 2);
}


control()
{
WORD	mevx, mevy,
	mevbut,
	keystate,
	keycode,
	mbreturn,
	msg_buf[8];
WORD	event,
	event_flag,
	m1_flag,
	m1_x, m1_y, m1_w, m1_h,	
	menu_index;

int 	a;
int     i;
int	clicked;
int destination;  /* used when moving voices etc. */
	
	m1_flag=0;

	graf_mouse(ARROW,0x0L); 

	menu_bar(menu_addr, TRUE); /* show menu  */
	objc_draw(tree_addr,0,10,0,0,x_max,y_max);/* draw mainscrren */
	
	event_flag=(MU_BUTTON | MU_M1 | MU_MESAG | MU_TIMER);

for(;;)
{
	event = evnt_multi( event_flag,
		0,
		01,
		1,
		m1_flag,
		box[3].g_x, box[3].g_y,
		box[3].g_w, box[3].g_h,
		0,		
		0, 0,
		0, 0,
		msg_buf,
		0, 0,
		&mevx, &mevy,
		&mevbut,
		&keystate,
		&keycode,
		&mbreturn);
		
	if (event & MU_MESAG)
	{
		if(msg_buf[0] != MN_SELECTED)
			continue;
		if(msg_buf[4] == QUIT)
			break;
			
		switch(msg_buf[4])
		{
		case INFORM:
		form_alert(0,"[0][for latest version & bank move|accessory send 10 (8 in UK)|Chris Rogers,11 Westhead Rd|Kidderminster |Worcs DY10 3TG England][O.K.]");
		break;

		case RESET:
      		trap(13,3,3,240);
      		trap(13,3,3,65);
      		trap(13,3,3,16);
      		trap(13,3,3,22);
      		trap(13,3,3,66);
      		trap(13,3,3,127);
      		trap(13,3,3,0);
      		trap(13,3,3,0);
      		trap(13,3,3,0);
      		trap(13,3,3,1);
      		trap(13,3,3,247);
		break;

		case SAVEVOC:
		save_voice();
		objc_draw(tree_addr,0,10,0,0,x_max,y_max);/* redraw mainscrren */
		break;
		
		case LOADVOC:
		load_voice();
		send_voice(4,0); /* to timbre temp part 1 */
		strcpy((((TEDINFO *)tree_addr[MEMORY].ob_spec)->te_ptext),voice.name);
		strcpy((((TEDINFO *)tree_addr[CHAN1].ob_spec)->te_ptext),"ST Memory");
		menu_addr[CPART1].ob_state = NORMAL;
		menu_addr[CPART2].ob_state = NORMAL;
		menu_addr[CPART3].ob_state = NORMAL;
		menu_addr[CPART4].ob_state = NORMAL;
		menu_addr[CCOMMON].ob_state = NORMAL;
		menu_addr[SAVEVOC].ob_state = NORMAL;
		objc_draw(tree_addr,0,10,0,0,x_max,y_max);/* redraw mainscrren */
		break;				

		case LOADBANK:
		load_bank();
		init_patchmem();        /* load current patches into structure */
		init_names();      	/* collect patch names from MT32 */
		crntpatch=3;
		init_mainscreen();	/* display initial values in mainscreen */
		init_system();

		objc_draw(tree_addr,0,10,0,0,x_max,y_max);/* redraw mainscrren */
		break;

		case SAVEBANK:
		save_bank();
		objc_draw(tree_addr,0,10,0,0,x_max,y_max);/* redraw mainscrren */
		break;

		case DRUMS:
		get_drums();/* fetch drum set up */
		show_rythm();/* display current rythm set up */
		edit_rythm();
		objc_draw(tree_addr,0,10,0,0,x_max,y_max);/* redraw mainscrren */
		break;

		case RANDOMIZ:
		do{
		objc_draw(ran_addr,0,10,0,0,x_max,y_max);/* draw randomise screen */
      		a=form_do(ran_addr,0); /* a holds value of exit button */
      		objc_change(ran_addr,a,0,0,0,x_max,y_max,NORMAL,0);
		objc_draw(tree_addr,0,10,0,0,x_max,y_max);/* redraw mainscrren */
		switch(a)
			{
			case DOIT:
	      		random();
			send_voice(4,0);
			break;
			
			case RANDSAVE:
			save_rand();
			break;

			case RANDLOAD:
			load_rand();
			break;
			}
		}while(a!=RANDCANC);
			
		break;

		case RESERVES:
      		do{
		objc_draw(ran_addr,0,10,0,0,x_max,y_max);/* draw randomise screen */
      		a=form_do(sys_addr,0); /* a holds value of exit button */
      		objc_change(ran_addr,a,0,0,0,x_max,y_max,NORMAL,0);
		i=0;
		for(a=RES1;a<=RES9;a++)
			{
			i+=atoi(((TEDINFO *)sys_addr[a].ob_spec)->te_ptext);
			}
		if(i!=32)form_alert(0,"[1][Total reserves must be 32][O.K.]");
		  }while(i!=32);
		objc_draw(tree_addr,0,10,0,0,x_max,y_max);/* redraw mainscrren */
		  
		if(a==SYSSEND)
		{
     		message[5]=16;   /* start address MSB */
     		message[6]=0;
     		message[7]=04;

     		for(a=0;a<18;a++){
	     		message[(a+8)]=(char)atoi(((TEDINFO *)sys_addr[a+RES1].ob_spec)->te_ptext);
                       	         }
          	send_dat(18);
		} 
		break;


	   	case CPART1: case CPART2: case CPART3: case CPART4: 

	menu_bar(menu_addr, FALSE); /* hide menu  */


	for(i=1;i<59;i++)/* set dialog to memory values */
	{
	strcpy((((TEDINFO *)box_addr[i].ob_spec)->te_ptext),dectoa(voice.partial[msg_buf[4]-CPART1][i-1]));
	}
	strcpy((((TEDINFO *)box_addr[TIMBNO].ob_spec)->te_ptext),voice.name);
	
	*(((TEDINFO *)box_addr[PARTINUM].ob_spec)->te_ptext)=msg_buf[4]-CPART1+0x31;
		edit_voice(msg_buf[4]-CPART1); /* Call routine to handle the dialog entry. */

	for(i=1;i<59;i++)/* set memory to new values */
	{
	voice.partial[msg_buf[4]-CPART1][i-1]=atoi(((TEDINFO *)box_addr[i].ob_spec)->te_ptext);
	}

	menu_bar(menu_addr, TRUE); /* show menu  */

	objc_draw(tree_addr,0,10,0,0,x_max,y_max);/* redraw mainscrren */

     	break;

	case CCOMMON:
	strcpy((((TEDINFO *)com_addr[COMNAME].ob_spec)->te_ptext),voice.name);
	com_addr[STR12CON].ob_spec=com_addr[STR0+voice.common[0]].ob_spec;
	com_addr[STR34CON].ob_spec=com_addr[STR0+voice.common[1]].ob_spec;

	if(voice.common[3]==0)  /* set envelope mode */
		{
		com_addr[CNORMAL].ob_state=SELECTED;
		com_addr[NOSUS].ob_state=NORMAL;
		}else{
		com_addr[CNORMAL].ob_state=NORMAL;
		com_addr[NOSUS].ob_state=SELECTED;
		}

	if(voice.common[2]&1){com_addr[MUT1].ob_state=SELECTED;}else{com_addr[MUT1].ob_state=NORMAL;}
	if(voice.common[2]&2){com_addr[MUT2].ob_state=SELECTED;}else{com_addr[MUT2].ob_state=NORMAL;}
	if(voice.common[2]&4){com_addr[MUT3].ob_state=SELECTED;}else{com_addr[MUT3].ob_state=NORMAL;}
	if(voice.common[2]&8){com_addr[MUT4].ob_state=SELECTED;}else{com_addr[MUT4].ob_state=NORMAL;}

	menu_bar(menu_addr, FALSE); /* hide menu  */

	edit_common();
	menu_bar(menu_addr, TRUE); /* show menu  */

	objc_draw(tree_addr,0,10,0,0,x_max,y_max);/* redraw mainscreen */
	break;	
	
	case HLPSYSBX:
	form_alert(0,"[1][point at the value you wish to|change. Hold left mouse button|and slide right to increase|or left to decrease. New value|will be sent when you let go][O.K.]");
	break;
		
	case HLPUSEME:
	form_alert(0,"[1][Shows the 64 User Memories |Click on up or down arrows to|scroll through. Drag selected|user voice to ST Memory box to|load into ST for editing][O.K.]");
	break;
	
	case HLPPTCHM:
	form_alert(0,"[1][Shows the 128 stored patches |Click on up or down arrows to|scroll through. Point at value|to change and drag right to|increase or left to decrease][O.K.]");
	break;
	
	case HLPCPRTM:
	form_alert(0,"[1][Shows patches currently chosen|Select channel to change and|scroll with up & down arrows.|Drag voice from top channel to|ST Memory box for editing][O.K.]");
	break;
	
	case HLPSTMEM:
	form_alert(0,"[1][Drag voice to here for editing|or load from disk. When loaded|use menu options to edit. Drag|from here to one of the user |memories.][O.K.]");
	break;
	
	case HLPPRTED:
	form_alert(0,"[1][Point to parameter to change|and whilst holding left button|drag right to increase or left|to decrease. Value sent when |let go. Click exit to return.][O.K.]");
	break;
	
	case HLPCOMED:
	form_alert(0,"[1][Click on name to change it.|When Changed press return.|Drag structure into boxes.|Highlighted partials are active][O.K.]");
	break;
	
	case HLPLDSVV:
	form_alert(0,"[1][Save the current voice to disk|or loads from disk into Memory|Use  '.VOC' as extension.][O.K.]");
	break;
	
	case HLPLDSVB:
	form_alert(0,"[1][Transfers all user memories,|patch memories, system area &|drum kit set up to or from|disk. A desk accessory is|available to re-load banks][O.K.]");
	break;
	
	case HLPRESET:
	form_alert(0,"[1][Resets MT32 to power on status.][O.K.]");
	break;
	
	case HLPRANDM:
	a=form_alert(2,"[1][Alters voice in memory up to|percentage shown. Highlighted|parameters are affected.Select|which partials to change (1-4)|Click do it to activate][Load/Save|More|O.K.]");
	if(a==1)form_alert(0,"[1][Transfers randomisation mask|to/from disk.|Doesn't save partial selection|Use '.MSK'extension][O.K.]");
	if(a==2)form_alert(0,"[1][Change value to alter depth of|effect.Highlight parameters to|be randomised by clicking.|Click on exit to return to|mainscreen and play new voice][O.K.]");

	break;
	
	case HLPRESRV:
	form_alert(0,"[1][Sets partial reserve and midi|receive channel for 8 current|voices. Total reserve must be|<=32. Point at value and slide|with left button down.][O.K.]");
	break;
	
	case HLPDRUMK:
	form_alert(0,"[1][Timbres 0-63 are user memories|64-93 are drums, 94 is off|Panpot 0 is right,14 is left.|Reverb 0 is off, 1 is on.|Red No. represents black key][O.K.]");
	break;
	
	case HLPARTCP:
	form_alert(0,"[0][Drag from partial to partial|or into temporary buffer for|storage. Buffer is kept during|voice loading & saving so can|transfer partial across voices][O.K.]");
	break;
			
	default:
	break;	
		}	
		
		menu_tnormal(menu_addr, msg_buf[3], 1);
		menu_bar(menu_addr, TRUE);	
	}	
	
	if(event & MU_BUTTON)
	{
		if(mevbut & 01)
		{
			clicked=(objc_find(tree_addr,MAINFORM,10,mevx,mevy));
			switch(clicked)
			{
			case USEMEM3:
				destination=move_box(clicked);
				switch(destination)
				{
				case MEMORY:
				strcpy((((TEDINFO *)tree_addr[MEMORY].ob_spec)->te_ptext),
				patch_name[2][crntuser]);
				objc_draw(tree_addr,STMEMBOX,5,0,0,x_max,y_max);/* redraw patch memory box*/
				get_voice(8,2*crntuser);
				send_voice(4,0); /* to timbre temp part 1 */
				mem_flag=1;/* set flag to show voice in memory */
				strcpy((((TEDINFO *)tree_addr[CHAN1].ob_spec)->te_ptext),"ST Memory");
				objc_draw(tree_addr,CHAN1,1,0,0,x_max,y_max);/* redraw patch memory box*/
				menu_addr[CPART1].ob_state = NORMAL;
				menu_addr[CPART2].ob_state = NORMAL;
				menu_addr[CPART3].ob_state = NORMAL;
				menu_addr[CPART4].ob_state = NORMAL;
				menu_addr[CCOMMON].ob_state = NORMAL;
				menu_addr[SAVEVOC].ob_state = NORMAL;
				menu_addr[RANDOMIZ].ob_state = NORMAL;
				
				}
			break;

			case MEMORY:
				destination=move_box(clicked);
				switch(destination)
				{
				case USEMEM3:
				send_voice(8,(crntuser*2)); /* to current user mem */
				strcpy((((TEDINFO *)tree_addr[USEMEM3].ob_spec)->te_ptext),voice.name);
				strcpy(patch_name[2][crntuser],voice.name); /* change name in computer */
				objc_draw(tree_addr,USEMEM3,1,0,0,x_max,y_max);/* redraw patch memory box*/
				}	
			break;


				case PATCHONE:
				strcpy((((TEDINFO *)tree_addr[PATCHONE].ob_spec)->te_ptext),
				patch_name[2][crntuser]);
				patch_memory[crntpatch].group=2;
				patch_memory[crntpatch].number=crntuser;				
				send_patch();
				show_patch(crntpatch);
				break;

			break;

			case UMUPARR:
				if(crntuser<64)show_users(++crntuser);
			break;
			
			case UMDNARR:
				if(crntuser>0)show_users(--crntuser);
			break;
			
			case PMUPARR:
				if(crntpatch<128)show_patch(++crntpatch);
			break;
			
			case PMDNARR:
				if(crntpatch>0)show_patch(--crntpatch);
 			break;
 			
	 		case TIMGRP:
 				patch_memory[crntpatch].group=slide_val(TIMGRP,mevx,patchmax[TIMGRP-TIMGRP]);
 				send_patch();
				strcpy((((TEDINFO *)tree_addr[PATCHONE].ob_spec)->te_ptext),
				  patch_name[patch_memory[crntpatch].group][patch_memory[crntpatch].number]);
				objc_draw(tree_addr,PATCHONE,10,0,0,x_max,y_max);/* redraw patch memory box*/

 			break;
 			
 			case TIMNO:
 				patch_memory[crntpatch].number=slide_val(TIMNO,mevx,patchmax[TIMNO-TIMGRP]);
 				send_patch();
				strcpy((((TEDINFO *)tree_addr[PATCHONE].ob_spec)->te_ptext),
				  patch_name[patch_memory[crntpatch].group][patch_memory[crntpatch].number]);
				objc_draw(tree_addr,PATCHONE,10,0,0,x_max,y_max);/* redraw patch memory box*/

 			break;
 			
 			case KEYSHIF:
 				patch_memory[crntpatch].key_shift=slide_val(KEYSHIF,mevx,patchmax[KEYSHIF-TIMGRP]);
 				send_patch();
 			break;
 			
 			case FINTUN:
 				patch_memory[crntpatch].fine_tune=slide_val(FINTUN,mevx,patchmax[FINTUN-TIMGRP]);
 				send_patch();
 			break;
 			
 			case BENDRNG:
				patch_memory[crntpatch].bend_range=slide_val(BENDRNG,mevx,patchmax[BENDRNG-TIMGRP]);
 				send_patch();
 			break;
 			
 			case ASSMODE:
				patch_memory[crntpatch].ass_mode=slide_val(ASSMODE,mevx,patchmax[ASSMODE-TIMGRP]);
 				send_patch();
 			break;
 			
 			case REVSW:
				patch_memory[crntpatch].rev_sw=slide_val(REVSW,mevx,patchmax[REVSW-TIMGRP]);
 				send_patch();
 			break;

			case MASTUN:
				system[0]=slide_val(MASTUN,mevx,127);
				send_sys();
			break;
			
			case REVMOD:
				system[1]=slide_val(REVMOD,mevx,3);
				send_sys();
			break;
			
			case REVTIM:
				system[2]=slide_val(REVTIM,mevx,7);
				send_sys();
			break;
			
			case REVLEV:
				system[3]=slide_val(REVLEV,mevx,7);
				send_sys();
			break;

			
			case MAINVOL:
				system[22]=slide_val(MAINVOL,mevx,100);
				send_sys();
			break;
			
 			
			case CHAN1:
			form_butn(tree_addr,0,clicked);
			crntchan=0;
				destination=move_box(clicked);
				switch(destination)
				{
				case MEMORY:
				get_voice(4,0);
				strcpy((((TEDINFO *)tree_addr[MEMORY].ob_spec)->te_ptext),voice.name);
				objc_draw(tree_addr,MEMORY,5,0,0,x_max,y_max);/* redraw memory box*/
				mem_flag=1;/* set flag to show voice in memory */
				strcpy((((TEDINFO *)tree_addr[CHAN1].ob_spec)->te_ptext),"ST Memory");
				menu_addr[CPART1].ob_state = NORMAL;
				menu_addr[CPART2].ob_state = NORMAL;
				menu_addr[CPART3].ob_state = NORMAL;
				menu_addr[CPART4].ob_state = NORMAL;
				menu_addr[CCOMMON].ob_state = NORMAL;
				}

			break;

			case CHAN2:
			form_butn(tree_addr,0,clicked);
			crntchan=1;
			break;

			case CHAN3:
			form_butn(tree_addr,0,clicked);
			crntchan=2;
			break;

			case CHAN4:
			form_butn(tree_addr,0,clicked);
			crntchan=3;
			break;

			case CHAN5:
			form_butn(tree_addr,0,clicked);
			crntchan=4;
			break;

			case CHAN6:
			form_butn(tree_addr,0,clicked);
			crntchan=5;
			break;
	
			case CHAN7:
			form_butn(tree_addr,0,clicked);
			crntchan=6;
			break;

			case CHAN8:
			form_butn(tree_addr,0,clicked);
			crntchan=7;
			break;


			case CHNUPARR:
			if(chan_contents[crntchan]<127)
				{
				chan_contents[crntchan]+=1;
				trap(13,3,3,(0xC1+crntchan));
				trap(13,3,3,chan_contents[crntchan]);
				show_chan(crntchan);
				}
			break;

			case CHNDNARR:
			if(chan_contents[crntchan]>0)
				{
				chan_contents[crntchan]-=1;
				trap(13,3,3,(0xC1+crntchan));
				trap(13,3,3,chan_contents[crntchan]);
				show_chan(crntchan);
				}
			break;
 			 			
			}
			}
		}		

	while (trap(13,1,3))
	{
	a=trap(13,2,3);
	trap(13,3,3,a);
	}
	

}
	return;	
}





edit_common()
{
WORD	mevx, mevy,
	mevbut,
	keystate,
	keycode,
	mbreturn,
	msg_buf[8];
WORD	event,
	event_flag,
	m1_flag,
	m1_x, m1_y, m1_w, m1_h,	
	menu_index;

int 	a;
int     i;
int	clicked;
int destination;  /* used when moving structure */
	
	m1_flag=0;
	graf_mouse(ARROW,0x0L); 

	event_flag=(MU_BUTTON | MU_MESAG | MU_TIMER);


	objc_draw(com_addr,0,10,0,0,x_max,y_max);/* draw common */

for(;;)
{
	event = evnt_multi( event_flag,
		0,
		01,
		1,
		m1_flag,
		box[3].g_x, box[3].g_y,
		box[3].g_w, box[3].g_h,
		0,		
		0, 0,
		0, 0,
		msg_buf,
		0, 0,
		&mevx, &mevy,
		&mevbut,
		&keystate,
		&keycode,
		&mbreturn);
		

		
	
	if(event & MU_BUTTON)
	{
		if(mevbut & 01)
		{
		clicked=(objc_find(com_addr,MAINFORM,10,mevx,mevy));
/* here */	switch(clicked)
		{
		case MUT1:	
		form_butn(com_addr,0,clicked);
		if(com_addr[MUT1].ob_state==SELECTED)
			{
			voice.common[2]|=1;
			}else{
			voice.common[2]&=14;
			}
		send_voice(4,0);
		break;
		
		case MUT2:	
		form_butn(com_addr,0,clicked);
		if(com_addr[MUT2].ob_state==SELECTED)
			{
			voice.common[2]|=2;
			}else{
			voice.common[2]&=13;
			}
		send_voice(4,0);
		break;
		
		case MUT3:	
		form_butn(com_addr,0,clicked);
		if(com_addr[MUT3].ob_state==SELECTED)
			{
			voice.common[2]|=4;
			}else{
			voice.common[2]&=11;
			}
		send_voice(4,0);
		break;
		
		case MUT4:	
		form_butn(com_addr,0,clicked);
		if(com_addr[MUT4].ob_state==SELECTED)
			{
			voice.common[2]|=8;
			}else{
			voice.common[2]&=7;
			}
		send_voice(4,0);
		break;
		
		case CNORMAL:
		form_butn(com_addr,0,clicked);
		voice.common[3]=0;
		send_voice(4,0);
		break;

		case NOSUS:		
		form_butn(com_addr,0,clicked);
		voice.common[3]=1;
		send_voice(4,0);
		break;		

		case STR0: case STR1: case STR2: case STR3: case STR4: case STR5: case STR6: 
		case STR7: case STR8: case STR9: case STR10: case STR11: case STR12:
		destination=move_part(clicked);
		if(destination==STR12CON)
		   {
		    voice.common[0]=clicked-STR0;
		    com_addr[STR12CON].ob_spec=com_addr[STR0+voice.common[0]].ob_spec;
		    objc_draw(com_addr,0,10,0,0,x_max,y_max);
		   }		
		if(destination==STR34CON)
		  {
		    voice.common[1]=clicked-STR0;
		    com_addr[STR34CON].ob_spec=com_addr[STR0+voice.common[1]].ob_spec;
		    objc_draw(com_addr,0,10,0,0,x_max,y_max);
		   }
		send_voice(4,0);
		break;   
		  
		   
		   
		case COMNAME:
			for(i=STRBOX12;i<STR12+1;i++)
			{
			com_addr[i].ob_state |= DISABLED;
			}
			
			com_addr[COMEXIT].ob_state = SHADOWED | OUTLINED;
			objc_draw(com_addr,0,10,0,0,x_max,y_max);/* draw common */
			
			form_do(com_addr,COMNAME);
			
			strcpy(voice.name,(((TEDINFO *)com_addr[COMNAME].ob_spec)->te_ptext));
			strcpy((((TEDINFO *)tree_addr[MEMORY].ob_spec)->te_ptext),voice.name);
			
			for(i=STRBOX12;i<STR12+1;i++)
			{
			com_addr[i].ob_state ^= DISABLED;
			}

			com_addr[COMEXIT].ob_state = SHADOWED | OUTLINED;
			objc_draw(com_addr,0,10,0,0,x_max,y_max);/* draw common */
			send_voice(4,0);

		break;
		}
		if(clicked==COMEXIT)break; 	
		}
	}		


	while (trap(13,1,3))
	{
	a=trap(13,2,3);
	trap(13,3,3,a);
	}
	

}
	return;	



}

move_part(start_ob)
int start_ob;
{
WORD sx, sy,
     fx, fy;
     
int mousex, mousey,
    mousbutn, shiftkey; 

int finish_ob;
     
     	graf_mouse(FLAT_HAND,0x0L);
     	objc_offset(com_addr,start_ob, &sx, &sy);
     	graf_dragbox(com_addr[start_ob].ob_w,
     		com_addr[start_ob].ob_h,
     		sx, sy,
		0,0,x_max,y_max,
		&fx, &fy);
	graf_mouse(ARROW,0x0L);
	graf_mkstate(&mousex, &mousey, &mousbutn, &shiftkey);
	finish_ob=(objc_find(com_addr,0,10,mousex, mousey));
	return(finish_ob);
}


save_voice()
{
int a;
int b;
int g;

        strcpy(name, "");
        strcpy(global_path, "A:\*.VOC");
        if(set_name()){
        fd=fopen(full_name, "w");
        if(fd==0)return;
                      }else{return;}

for(b=0;b<4;b++)
  {

     for(a=0;a<59;a++)
      {
       g=(char)voice.partial[b][a];
      fprintf(fd,"%d\n",g);
      }

  }

     for(a=8;a<18;a++)
     {
     if(isalnum(voice.name[a-8]))
     message[a]=voice.name[a-8];
     else
     message[a]=32;
     }

                            /* get structure etc */     
     message[18]=voice.common[0];
     message[19]=voice.common[1];
     message[20]=voice.common[2];
     message[21]=voice.common[3];

     for(a=8;a<22;a++)
       {
      fprintf(fd,"%d\n",message[a]);
       }
fclose(fd);
}

set_name()
{
short int i;
short int a;
        a=fsel_input(global_path, name, &i);
        if((i==0)||(a==0)){
          return(0);
               }else{
                strcpy (full_name, global_path);                      
                for (i=strlen(full_name);full_name[i-1]!='\\';i--);
                full_name[i] = '\0';
                strcat (full_name, name);

             for (i=0;i<strlen(full_name);i++) 
                if (full_name[i] == '\n')
                     full_name[i] = '\0';

return(1);}
}


load_voice()
{
char f[];
int g;
int b, a;

        strcpy(name, "");
        strcpy(global_path, "A:\*.VOC");
        if(set_name()){
        fd=fopen(full_name, "r");
        if(fd==0)return;
                      }else{return;}



for(b=0;b<4;b++)
  {
     for(a=0;a<59;a++)
      {
       fgets(f,7,fd);
       g=atoi(f);
	voice.partial[b][a]=(char)g;
      }
  }

     for(a=0;a<10;a++)
     {
     fgets(f,5,fd);
     voice.name[a]=atoi(f) ;
     }
                            /* get structure etc */     
     for(a=0;a<4;a++)
     {
     fgets(f,5,fd);
     g=atoi(f);
     voice.common[a]=g;
     }
fclose(fd);

}



tim_mem_fetch()
{
int c, a;
unsigned char val[246];

for(c=0;c<64;c++){
     	message[4]=17; /* data request code */
     message[8]=0;    /* size MSB */
     message[9]=1;    /* size     */
     message[10]=118; /* size LSB */
     message[5]=8;    /* start address MSB */
     message[6]=(c*2);/* timbre memory no */
     message[7]=0;

     send_req();

     for(a=0;a<246;a++) /* read incoming data into memory */
      {
      val[a]=((trap(13,2,3))&127);
      }

     fwrite(val,246,1,fd);

                 }

}




patch_fetch()
{
int c, a;
unsigned char val[128];


for(c=0;c<8;c++){
     	message[4]=17; /* data request code */
     message[8]=0;    /* size MSB          */
     message[9]=1;    /* size 128 bytes    */
     message[10]=0;   /* size LSB          */
     message[5]=5;    /* start address MSB */
     message[6]=c;
     message[7]=0;
     send_req();

     for(a=0;a<128;a++) /* read incoming data into memory */
      {
      val[a]=((trap(13,2,3))&127);
      }

     fwrite(val,128,1,fd);
                 }
}

sys_fetch()
{
int c, a;
unsigned char val[23];

     	message[4]=17; /* data request code */
     message[8]=0;    /* size MSB          */
     message[9]=0;    /* size              */
     message[10]=23;  /* size LSB          */
     message[5]=16;   /* start address MSB */
     message[6]=0;
     message[7]=0;
     send_req();

     for(a=0;a<23;a++) /* read incoming data into memory */
      {
      val[a]=((trap(13,2,3))&127);
      }

     fwrite(val,23,1,fd);
}

rythm_fetch()
{

int a;
int b;
unsigned char val[128];

/* read current drum settings  */

for(b=1;b<3;b++)
  {
     message[4]=17; /* data request code */
     message[5]=3;
     if(b==1){message[6]=1;}else{message[6]=2;}
     message[7]=16;
     message[8]=0;
     message[9]=1;
     message[10]=0;

     send_req();

     for(a=0;a<128;a++) /* read incoming data into memory */
      {
     val[a]=((trap(13,2,3))&127);
      }

     fwrite(val,128,1,fd);


  }
}

tim_send()
{
int c, a;
unsigned char val[246];

for(c=0;c<64;c++){
     message[5]=8;    /* start address MSB */
     message[6]=(c*2);/* timbre memory no */
     message[7]=0;

     fread(val,246,1,fd);

     for(a=0;a<246;a++){
     message[(a+8)]=val[a];
                       }

          send_dat(246);
                 }

}


send_dat(k)
int k;
{
int a;
message[4]=18;
message[(k+8)]=calchk(k+8);
message[(k+9)]=247;

     for(a=0;a<(k+10);a++){
          trap(13,3,3,message[a]);
                         }

}
          

patch_send()
{
int c, a;
unsigned char val[128];


for(c=0;c<8;c++){
     message[5]=5;    /* start address MSB */
     message[6]=c;
     message[7]=0;
     fread(val,128,1,fd);

     for(a=0;a<128;a++){
     message[(a+8)]=val[a];
                       }

          send_dat(128);
                 }
}



sys_send()
{
int c, a;
unsigned char val[23];
     message[5]=16;   /* start address MSB */
     message[6]=0;
     message[7]=0;

     fread(val,23,1,fd);

     for(a=0;a<23;a++){
     message[(a+8)]=val[a];
                       }

          send_dat(23);

}

rythm_send()
{

int a;
int b;
unsigned char val[128];


for(b=1;b<3;b++)
  {
     message[5]=3;
     if(b==1){message[6]=1;}else{message[6]=2;}
     message[7]=16;

     fread(val,128,1,fd);

     for(a=0;a<128;a++){
     message[(a+8)]=val[a];
                       }

          send_dat(128);
  }
}


load_bank()
{
        message[4]=18;   /* data set  */
        	strcpy( name, "");
        	strcpy(global_path, "A:\*.BNK");
        	if(set_name()){
        			fd=fopen(full_name, "r");
        			if(fd==0)return;
                      		}else{return;}
         tim_send();
         patch_send();
         rythm_send();
         sys_send();

fclose(fd);

}


save_bank()
{
       	strcpy(name, "");
       	strcpy(global_path, "A:\*.BNK");
       	if(set_name()){
       			fd=fopen(full_name, "w");
       			if(fd==0)return;
               		}else{return;}
       	tim_mem_fetch();
       	patch_fetch();
       	rythm_fetch();
       	sys_fetch();
fclose(fd);

}



random()
{
int a;
int b;
int c;
int current;

int variation;
for(b=0;b<4;b++)
    {
     if(ran_addr[PAR1+b].ob_state & SELECTED){ /* if this partial selected */
     for(a=1;a<59;a++)
         {
          if(ran_addr[a].ob_state & SELECTED){ /* if selected randomise */
          current=voice.partial[b][a-1];

            variation=(((atoi(((TEDINFO *)ran_addr[a].ob_spec)->te_ptext))*(Rand()&255)*partmax[(a-1)])+1)/25500+1;
               if((Rand()&255)>126){
               c=current+((variation+1)/2);
                                   }else{
               c=current-((variation+1)/2);
                                        }
             if(c>partmax[(a-1)]){c=partmax[(a-1)];}
             if(c<0){c=0;}  

             voice.partial[b][a-1]=c;
                             }


          }
                             }
     }
}

save_rand()
{
int a;
unsigned char val[58];

       	strcpy(name, "");
       	strcpy(global_path, "A:\*.MSK");
       	if(set_name()){
       			fd=fopen(full_name, "w");
       			if(fd==0)return;
               		}else{return;}


	for(a=COARSE;a<=RTVALVL4;a++) /* read incoming data into memory */
	{
	val[a-COARSE]=((unsigned char)(atoi(((TEDINFO *)ran_addr[a].ob_spec)->te_ptext)))+(128*(ran_addr[a].ob_state & SELECTED));
	}

	fwrite(val,58,1,fd);

fclose(fd);
}

load_rand()
{
int a;
unsigned char val[58];

       	strcpy(name, "");
       	strcpy(global_path, "A:\*.MSK");
       	if(set_name()){
       			fd=fopen(full_name, "r");
       			if(fd==0)return;
               		}else{return;}

	fread(val,58,1,fd);

	for(a=COARSE;a<=RTVALVL4;a++) /* read incoming data into memory */
	{
	strcpy((((TEDINFO *)ran_addr[a].ob_spec)->te_ptext),dectoa(val[a-COARSE]&127));
	if(val[a-COARSE]>127)ran_addr[a].ob_state=SELECTED;
	}



fclose(fd);
}



get_drums()
{
int a;
int b;
int v;

/* read current drum settings  */

for(b=1;b<3;b++)
  {
     message[4]=17;
     message[5]=3;
     if(b==1){message[6]=1;}else{message[6]=2;}
     message[7]=16;
     message[8]=0;
     message[9]=1;
     message[10]=0;
     message[11]=calchk(11);
     message[12]=247;

     for(a=0;a<13;a++) /* send data request  */
     {
      trap(13,3,3,(message[a]));
     }

     while((trap(13,2,3)&255)!=240)
        ; /* wait for sys ex maessage  */

     for(a=1;a<8;a++)
      {
      v=trap(13,2,3); /* read id's and address */
      }



     for(a=0;a<128;a++) /* read incoming data into memory */
      {
     v=trap(13,2,3)&255;
     if(v>100){v=94;}/* to stop timbre numbres of -255 */
     rythm[a+(b-1)*128]=v;
      }

     v=trap(13,2,3);
     v=trap(13,2,3);

  }
}


show_rythm()
{
int a;
	for(a=0;a<256;a++)
	{
	strcpy((((TEDINFO *)ryt_addr[a+RYTTIM24].ob_spec)->te_ptext),dectoa(rythm[a]));
	}
	objc_draw(ryt_addr,0,3,0,0,x_max,y_max);/* redraw rythm screen*/
}


edit_rythm()
{
WORD	mevx, mevy,
	mevbut,
	keystate,
	keycode,
	mbreturn,
	msg_buf[8];

WORD	event,
	event_flag,
	m1_flag,
	m1_x, m1_y, m1_w, m1_h,	
	menu_index;

int 	a;
int     i;
int	clicked;

	
	m1_flag=0;

	event_flag=(MU_BUTTON | MU_TIMER);

for(;;)
{
	event = evnt_multi( event_flag,
		0,
		01,
		1,
		m1_flag,
		box[3].g_x, box[3].g_y,
		box[3].g_w, box[3].g_h,
		0,		
		0, 0,
		0, 0,
		msg_buf,
		0, 0,
		&mevx, &mevy,
		&mevbut,
		&keystate,
		&keycode,
		&mbreturn);
		
	if(event & MU_BUTTON)
	{
		if(mevbut & 01)
		{
		clicked=(objc_find(ryt_addr,0,10,mevx,mevy));
		if((clicked>0)&&(clicked<=256))
			{
			rythm[clicked-1]=slider_val(clicked,mevx,rytmax[(clicked-1)%4]);
			drum_send();
			}
		if(clicked==RYTQUIT)break; 	
		}
	}		

	while (trap(13,1,3))
	{
	a=trap(13,2,3);
	trap(13,3,3,a);
	}
	

}
	return;	
}

                          
                                   
                                   
                               
                               
                                     
                                     

                  
                  
                  
                  
slider_val(target,mousepot,max_allowed)
int target,mousepot,max_allowed;
{
int a;
int 	temp,change;
int 	mousex,mousey,
	mousbutn,shiftkey;
  	mousex=mousepot;
	temp=atoi(((TEDINFO *)ryt_addr[target].ob_spec)->te_ptext);


	  /* increment values with mouse sliding */
	do{ 
		temp=temp+(mousepot<mousex)-(mousepot>mousex);
		if(temp<0)temp=0;      /* compare to max and min allowed */
		if(temp>max_allowed)temp=max_allowed;
		strcpy((((TEDINFO *)ryt_addr[target].ob_spec)->te_ptext),
							    dectoa(temp));
		objc_draw(ryt_addr,target,2,0,0,x_max,y_max);
		for(a=0;a<20000;a++);  /* slow it down */
		graf_mkstate(&mousex,&mousey,&mousbutn,&shiftkey);
       }while(mousbutn==1);

	return(atoi(((TEDINFO *)ryt_addr[target].ob_spec)->te_ptext));

}


drum_send()
{
int a;
int b;
for(b=1;b<3;b++)
  {
     message[4]=18;
     message[5]=3;
     if(b==1){message[6]=1;}else{message[6]=2;}
     message[7]=16;

    for(a=8;a<136;a++)
      {
       message[a]=rythm[(a-8)+((b-1)*128)];
      }

     message[135]=calchk(135);
     message[136]=247;


     for(a=0;a<137;a++)
       {
        trap(13,3,3,message[a]);
       }
  }

}

check_mt()		/* check prescence of MT32 */
{
int a;

     message[4]=17; /* data request code */
     message[5]=3;
     message[6]=0;
     message[7]=0;
     message[8]=0;
     message[9]=0;
     message[10]=1;
     message[11]=calchk(11);
     message[12]=247;

	while (trap(13,1,3))
	{
	trap(13,2,3);  /* clear midi input buffer */
	}


    	for(a=0;a<13;a++) /* send data request  */
     	{
      	trap(13,3,3,message[a]);
     	}

	for(a=0;a<20000;a++);  /* wait */

	if(!(trap(13,1,3)))
	{
	form_alert(0,"[1][you must have a Roland MT32|or Roland D110 connected][O.K.]");
	rsrc_free();/* clear the resource memory */
	v_clsvwk(screen_vhandle);/* clear the screen */
	appl_exit();/* tidy up */
	}
}

